/*
 * Copyright (c) 2015, Olivier MATZ <zer0@droids-corp.org>
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef UGC_STM32_UART_H_
#define UGC_STM32_UART_H_

#include <stm32f4xx.h>

#include <ucg_uart.h>

struct ucg_stm32_uart {
						/* Example: */
	USART_TypeDef *uart;                    /* USART2 */
	uint32_t rcc_uart;                      /* RCC_APB1Periph_USART2 */
	uint32_t rcc_gpio;                      /* RCC_AHB1Periph_GPIOA */
	GPIO_TypeDef *gpio;                     /* GPIOA */
	uint8_t gpio_af;                        /* GPIO_AF_USART2 */
	uint16_t gpio_pins;                     /* GPIO_Pin_2 | GPIO_Pin_3 */
	uint8_t gpio_speed;                     /* GPIO_Speed_25MHz */
	uint8_t irq;                            /* USART2_IRQn */
	uint8_t irq_preempt_prio;               /* 0 */
	uint8_t irq_sub_prio;                   /* 0 */
};

const struct ucg_uart_driver_ops stm32_uart_ops;

#endif /* UGC_STM32_UART_H_ */
