/*
 * Copyright (c) 2013, Olivier MATZ <zer0@droids-corp.org>
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

#include <cfzy_log.h>

#include "test_expr.h"
#include "test_conftree.h"
#include "test_dotconfig.h"

int main(int argc, char **argv)
{
	int ret = 0;

	(void)argc;

	/* XXX a cfzy_init() would be better */
	cfzy_log_init();

	printf("=== test expression parser ===\n");
	if (test_expr() < 0) {
		printf("failed\n");
		ret = 1;
	}
	else
		printf("success\n");

	printf("=== test conf tree ===\n");
	if (test_conftree(argv[0]) < 0) {
		printf("failed\n");
		ret = 1;
	}
	else
		printf("success\n");

	printf("=== test .config ===\n");
	if (test_dotconfig(argv[0]) < 0) {
		printf("failed\n");
		ret = 1;
	}
	else
		printf("success\n");

	cfzy_log_exit();

	if (ret == 0)
		printf("\n=== SUCCES ===\n");
	else
		printf("\n=== FAILED ===\n");

	return ret;
}
